package com.gmail.nossr50.config.antiexploit;

import ninja.leaping.configurate.objectmapping.Setting;
import ninja.leaping.configurate.objectmapping.serialize.ConfigSerializable;

@ConfigSerializable
public class ConfigSectionExploitSalvage {

    private static final boolean ALLOW_UNSAFE_DEFAULT = false;

    @Setting(value = "Allow-Illegal-Enchantments", comment = "If set to true, mcMMO will allow salvage to create books with illegal enchants." +
            "\nIf set to false, mcMMO will downgrade the enchantment to its native max level before calculating results." +
            "\nAn illegal enchant is one that is not obtainable through normal gameplay without mods or cheats." +
            "\nDefault value: "+ALLOW_UNSAFE_DEFAULT)
    private boolean allowUnsafeEnchants = ALLOW_UNSAFE_DEFAULT;

    public boolean isAllowUnsafeEnchants() {
        return allowUnsafeEnchants;
    }

}
