package com.gmail.nossr50.config.antiexploit;

import ninja.leaping.configurate.objectmapping.Setting;
import ninja.leaping.configurate.objectmapping.serialize.ConfigSerializable;

@ConfigSerializable
public class ConfigSectionExploitSkills {
    @Setting(value = "Acrobatics", comment = "Exploit settings related to Acrobatics")
    private ConfigSectionExploitAcrobatics configSectionExploitAcrobatics = new ConfigSectionExploitAcrobatics();

    @Setting(value = "Fishing", comment = "Exploit settings related to Fishing")
    private ConfigSectionExploitFishing configSectionExploitFishing = new ConfigSectionExploitFishing();

    @Setting(value = "Mining", comment = "Exploit settings related to Mining")
    private ConfigSectionExploitMining configSectionExploitMining = new ConfigSectionExploitMining();

    @Setting(value = "Herbalism", comment = "Exploit settings related to Herbalism.")
    private ConfigSectionExploitHerbalism configSectionExploitHerbalism = new ConfigSectionExploitHerbalism();

    @Setting(value = "Repair", comment = "Exploit settings related to Repair.")
    private ConfigSectionExploitRepair configSectionExploitRepair = new ConfigSectionExploitRepair();

    @Setting(value = "Salvage", comment = "Exploit settings related to Salvage")
    private ConfigSectionExploitSalvage configSectionExploitSalvage = new ConfigSectionExploitSalvage();

    @Setting(value = "Taming", comment = "Exploit settings related to Taming")
    private ConfigSectionExploitTaming configSectionExploitTaming = new ConfigSectionExploitTaming();

    @Setting(value = "Excavation", comment = "Exploit settings related to Excavation.")
    private ConfigSectionExploitExcavation configSectionExploitExcavation = new ConfigSectionExploitExcavation();

    public ConfigSectionExploitAcrobatics getConfigSectionExploitAcrobatics() {
        return configSectionExploitAcrobatics;
    }

    public ConfigSectionExploitFishing getConfigSectionExploitFishing() {
        return configSectionExploitFishing;
    }

    public ConfigSectionExploitHerbalism getConfigSectionExploitHerbalism() {
        return configSectionExploitHerbalism;
    }

    public ConfigSectionExploitMining getConfigSectionExploitMining() {
        return configSectionExploitMining;
    }

    public boolean isPreventCobblestoneStoneGeneratorXP() {
        return configSectionExploitMining.isPreventCobblestoneStoneGeneratorXP();
    }

    public boolean isSnowGolemExploitPrevented() {
        return configSectionExploitExcavation.isSnowGolemExploitPrevented();
    }

    public boolean areSummonsBreedable() {
        return configSectionExploitTaming.areSummonsBreedable();
    }

    public boolean isPreventVehicleAutoFarming() {
        return configSectionExploitHerbalism.isPreventVehicleAutoFarming();
    }

    public long getFishingRodSpamMilliseconds() {
        return configSectionExploitFishing.getFishingRodSpamMilliseconds();
    }

    public double getOverFishingAreaSize() {
        return configSectionExploitFishing.getOverFishingAreaSize();
    }

    public boolean isPreventFishingExploits() {
        return configSectionExploitFishing.isPreventFishingExploits();
    }

    public int getOverfishingLimit() {
        return configSectionExploitFishing.getOverfishingLimit();
    }

    public boolean isAlertAdminsOnOverFishing() {
        return configSectionExploitFishing.isAlertAdminsOnOverFishing();
    }

    public int getRollXPGainCooldownSeconds() {
        return configSectionExploitAcrobatics.getRollXPGainCooldownSeconds();
    }

    public int getTeleportCooldownSeconds() {
        return configSectionExploitAcrobatics.getTeleportCooldownSeconds();
    }

    public int getAcrobaticLocationLimit() {
        return configSectionExploitAcrobatics.getAcrobaticLocationLimit();
    }

    public boolean isPreventAcrobaticsAbuse() {
        return configSectionExploitAcrobatics.isPreventAcrobaticsAbuse();
    }

    public ConfigSectionExploitRepair getConfigSectionExploitRepair() {
        return configSectionExploitRepair;
    }

    public ConfigSectionExploitSalvage getConfigSectionExploitSalvage() {
        return configSectionExploitSalvage;
    }

    public ConfigSectionExploitTaming getConfigSectionExploitTaming() {
        return configSectionExploitTaming;
    }
}
